// EX4 definitions

#include <stdio.h>
#include <tchar.h>
#include <windows.h>
#include <assert.h>

#define QUEUE_MAX_COUNT			13
#define ALMOST_INFINITE         100000
#define MMF_NAME				_T("EX4.SHARED.QUEUE.MMF")
#define GUARD_MUTEX_NAME		_T("EX4.SHARED.QUEUE.MUTEX")
#define READER_SEM_NAME			_T("EX4.SHARED_QUEUE.READER_SEMAPHORE")
#define WRITER_SEM_NAME			_T("EX4.SHARED_QUEUE.WRITER_SEMAPHORE")

typedef struct
{
	DWORD					m_dwCount;
	DWORD					m_dwHead;
	DWORD					m_dwTail;
} SHARED_QUEUE_HEADER;

typedef struct
{
	SHARED_QUEUE_HEADER*	m_pHeader;
	DWORD*					m_pQueue;
	HANDLE					m_hMutex;
	HANDLE					m_hReadSem;
	HANDLE					m_hWriteSem;
	HANDLE					m_hMapFile;
	BYTE*					m_pBuffer;
} SHARED_QUEUE;