// ex06.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <conio.h>
#include <assert.h>

#define N 20

// calculator function
void runCalc(int *arr){
	TCHAR Op_code;
	unsigned int op1, op2, res;
	TCHAR input[256];

	while (1) {
		_getts(input);
		_stscanf(input,_T("%c %d %d %d"), &Op_code, &op1, &op2, &res);

		__try {
		switch (Op_code){
			case 'm': 
				arr[res] = arr[op1]*arr[op2];
				break;
			case 'd':
				arr[res] = arr[op1]/arr[op2];
				break;
			case 's':
				arr[res] = arr[op1]-arr[op2];
				break;
			default:
				_tprintf(_T("unknown command, enter another input:\n"));
		}
		} __except((GetExceptionCode()==EXCEPTION_INT_DIVIDE_BY_ZERO)?EXCEPTION_EXECUTE_HANDLER:EXCEPTION_CONTINUE_SEARCH){
			arr[res] = 0;
		}

		_tprintf(_T("%d %d %d\n"),arr[op1],arr[op2],arr[res]);
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	// allocate an array
	int *arr;
	arr = (int *) malloc(N*sizeof(int));
	assert(arr != NULL);

	// fill array with random values
	int i;
	for (i=0; i<N; i++) arr[i] = rand();

	__try
	{
		// run calculator
		runCalc(arr);
	} __except(EXCEPTION_EXECUTE_HANDLER){
		_tprintf(_T("error\n"));
		_getch();
	}

	return 0;
}

