// client.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <assert.h>
#include <conio.h>
#define MAX_SIZE 256

//client code
int _tmain(int argc, _TCHAR* argv[])
{
	//initialize windows sockets service
	WSADATA wsaData;
	int iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	assert(iResult==NO_ERROR);

	//prepare server address
	sockaddr_in server_addr;
	server_addr.sin_family = AF_INET;
	server_addr.sin_addr.s_addr = inet_addr("127.0.0.1");
	server_addr.sin_port = htons(27015);

	do
	{
		//create socket
		SOCKET hServerSocket= socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
		assert(hServerSocket!=INVALID_SOCKET);

		//connect to server
		int nRes=connect( hServerSocket, (SOCKADDR*) &server_addr, sizeof(server_addr));
		assert(nRes!=SOCKET_ERROR);

		//prepare buffer for incoming data
		char buf[MAX_SIZE];
		int nLeft=sizeof(buf);
		int iPos=0;

		do //loop till there are no more data
		{
			int nNumBytes=recv(hServerSocket,buf+iPos,nLeft,0);

			//check if cleint closed connection
			if(!nNumBytes) break;

			assert(nNumBytes!=SOCKET_ERROR);

			//update free space and pointer to next byte
			nLeft-=nNumBytes;
			iPos+=nNumBytes;

		}while(1);

		//close socket
		closesocket(hServerSocket);

		// print server's message
		printf("%s\n",buf);
		
		// wait for any char to exit
		_getch();
		break;
	
	} while (1);

	//release windows socket resources
	WSACleanup();

	return 0;
}